/*
 * morse.h
 *
 * Created: 18/05/2021 15:47:24
 *  Author: yboujon1
 */ 

#include "main.h"
#include "timerinterrupt.h"
#include "lcd.h"

#define POINT 1
#define TRAIT 3
#define INTERLETTRE 30
#define INTERMOT 70
#define FIN 0
#define LETTRES 36

void envoyer_signe_morse(unsigned char signe_morse);
void maj2min_convert(char *tab, int n);         //elle traduit des majuscules en minuscules
void latin2morse(char *tab, int n);             //elle cherche les correspondances par rapport a la librairie ou non
void morselibrary_output(int id);                      //elle traduit en morse par rapport a la librairie
void envoie_morse(char morse);                  //elle envoie le caractere en morse
void library_checker(char *tab,int* i,int* j);  //traduit dans la librairie et ajoute un intermot si possible
void simple_terms(char *tab,int* i,int* j);     //traduit les espaces et les fins de message
void lcd_char(char *tab,int* i);

unsigned char morse_library[LETTRES][7];